# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['ApplicationArgs', 'Application']

@pulumi.input_type
class ApplicationArgs:
    def __init__(__self__, *,
                 config_contract: pulumi.Input[str],
                 implementation: pulumi.Input[str],
                 sync_level: pulumi.Input[str],
                 anime_sync_categories: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 api_key: Optional[pulumi.Input[str]] = None,
                 base_url: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 prowlarr_url: Optional[pulumi.Input[str]] = None,
                 sync_categories: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None):
        """
        The set of arguments for constructing a Application resource.
        :param pulumi.Input[str] config_contract: Application configuration template.
        :param pulumi.Input[str] implementation: Application implementation name.
        :param pulumi.Input[str] sync_level: Sync level.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] anime_sync_categories: Anime sync categories.
        :param pulumi.Input[str] api_key: API key.
        :param pulumi.Input[str] base_url: Base URL.
        :param pulumi.Input[str] name: Application name.
        :param pulumi.Input[str] prowlarr_url: Prowlarr URL.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] sync_categories: Sync categories.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] tags: List of associated tags.
        """
        pulumi.set(__self__, "config_contract", config_contract)
        pulumi.set(__self__, "implementation", implementation)
        pulumi.set(__self__, "sync_level", sync_level)
        if anime_sync_categories is not None:
            pulumi.set(__self__, "anime_sync_categories", anime_sync_categories)
        if api_key is not None:
            pulumi.set(__self__, "api_key", api_key)
        if base_url is not None:
            pulumi.set(__self__, "base_url", base_url)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if prowlarr_url is not None:
            pulumi.set(__self__, "prowlarr_url", prowlarr_url)
        if sync_categories is not None:
            pulumi.set(__self__, "sync_categories", sync_categories)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter(name="configContract")
    def config_contract(self) -> pulumi.Input[str]:
        """
        Application configuration template.
        """
        return pulumi.get(self, "config_contract")

    @config_contract.setter
    def config_contract(self, value: pulumi.Input[str]):
        pulumi.set(self, "config_contract", value)

    @property
    @pulumi.getter
    def implementation(self) -> pulumi.Input[str]:
        """
        Application implementation name.
        """
        return pulumi.get(self, "implementation")

    @implementation.setter
    def implementation(self, value: pulumi.Input[str]):
        pulumi.set(self, "implementation", value)

    @property
    @pulumi.getter(name="syncLevel")
    def sync_level(self) -> pulumi.Input[str]:
        """
        Sync level.
        """
        return pulumi.get(self, "sync_level")

    @sync_level.setter
    def sync_level(self, value: pulumi.Input[str]):
        pulumi.set(self, "sync_level", value)

    @property
    @pulumi.getter(name="animeSyncCategories")
    def anime_sync_categories(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]:
        """
        Anime sync categories.
        """
        return pulumi.get(self, "anime_sync_categories")

    @anime_sync_categories.setter
    def anime_sync_categories(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]):
        pulumi.set(self, "anime_sync_categories", value)

    @property
    @pulumi.getter(name="apiKey")
    def api_key(self) -> Optional[pulumi.Input[str]]:
        """
        API key.
        """
        return pulumi.get(self, "api_key")

    @api_key.setter
    def api_key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "api_key", value)

    @property
    @pulumi.getter(name="baseUrl")
    def base_url(self) -> Optional[pulumi.Input[str]]:
        """
        Base URL.
        """
        return pulumi.get(self, "base_url")

    @base_url.setter
    def base_url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "base_url", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Application name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="prowlarrUrl")
    def prowlarr_url(self) -> Optional[pulumi.Input[str]]:
        """
        Prowlarr URL.
        """
        return pulumi.get(self, "prowlarr_url")

    @prowlarr_url.setter
    def prowlarr_url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "prowlarr_url", value)

    @property
    @pulumi.getter(name="syncCategories")
    def sync_categories(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]:
        """
        Sync categories.
        """
        return pulumi.get(self, "sync_categories")

    @sync_categories.setter
    def sync_categories(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]):
        pulumi.set(self, "sync_categories", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]:
        """
        List of associated tags.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]):
        pulumi.set(self, "tags", value)


@pulumi.input_type
class _ApplicationState:
    def __init__(__self__, *,
                 anime_sync_categories: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 api_key: Optional[pulumi.Input[str]] = None,
                 base_url: Optional[pulumi.Input[str]] = None,
                 config_contract: Optional[pulumi.Input[str]] = None,
                 implementation: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 prowlarr_url: Optional[pulumi.Input[str]] = None,
                 sync_categories: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 sync_level: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None):
        """
        Input properties used for looking up and filtering Application resources.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] anime_sync_categories: Anime sync categories.
        :param pulumi.Input[str] api_key: API key.
        :param pulumi.Input[str] base_url: Base URL.
        :param pulumi.Input[str] config_contract: Application configuration template.
        :param pulumi.Input[str] implementation: Application implementation name.
        :param pulumi.Input[str] name: Application name.
        :param pulumi.Input[str] prowlarr_url: Prowlarr URL.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] sync_categories: Sync categories.
        :param pulumi.Input[str] sync_level: Sync level.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] tags: List of associated tags.
        """
        if anime_sync_categories is not None:
            pulumi.set(__self__, "anime_sync_categories", anime_sync_categories)
        if api_key is not None:
            pulumi.set(__self__, "api_key", api_key)
        if base_url is not None:
            pulumi.set(__self__, "base_url", base_url)
        if config_contract is not None:
            pulumi.set(__self__, "config_contract", config_contract)
        if implementation is not None:
            pulumi.set(__self__, "implementation", implementation)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if prowlarr_url is not None:
            pulumi.set(__self__, "prowlarr_url", prowlarr_url)
        if sync_categories is not None:
            pulumi.set(__self__, "sync_categories", sync_categories)
        if sync_level is not None:
            pulumi.set(__self__, "sync_level", sync_level)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter(name="animeSyncCategories")
    def anime_sync_categories(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]:
        """
        Anime sync categories.
        """
        return pulumi.get(self, "anime_sync_categories")

    @anime_sync_categories.setter
    def anime_sync_categories(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]):
        pulumi.set(self, "anime_sync_categories", value)

    @property
    @pulumi.getter(name="apiKey")
    def api_key(self) -> Optional[pulumi.Input[str]]:
        """
        API key.
        """
        return pulumi.get(self, "api_key")

    @api_key.setter
    def api_key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "api_key", value)

    @property
    @pulumi.getter(name="baseUrl")
    def base_url(self) -> Optional[pulumi.Input[str]]:
        """
        Base URL.
        """
        return pulumi.get(self, "base_url")

    @base_url.setter
    def base_url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "base_url", value)

    @property
    @pulumi.getter(name="configContract")
    def config_contract(self) -> Optional[pulumi.Input[str]]:
        """
        Application configuration template.
        """
        return pulumi.get(self, "config_contract")

    @config_contract.setter
    def config_contract(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "config_contract", value)

    @property
    @pulumi.getter
    def implementation(self) -> Optional[pulumi.Input[str]]:
        """
        Application implementation name.
        """
        return pulumi.get(self, "implementation")

    @implementation.setter
    def implementation(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "implementation", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Application name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="prowlarrUrl")
    def prowlarr_url(self) -> Optional[pulumi.Input[str]]:
        """
        Prowlarr URL.
        """
        return pulumi.get(self, "prowlarr_url")

    @prowlarr_url.setter
    def prowlarr_url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "prowlarr_url", value)

    @property
    @pulumi.getter(name="syncCategories")
    def sync_categories(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]:
        """
        Sync categories.
        """
        return pulumi.get(self, "sync_categories")

    @sync_categories.setter
    def sync_categories(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]):
        pulumi.set(self, "sync_categories", value)

    @property
    @pulumi.getter(name="syncLevel")
    def sync_level(self) -> Optional[pulumi.Input[str]]:
        """
        Sync level.
        """
        return pulumi.get(self, "sync_level")

    @sync_level.setter
    def sync_level(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "sync_level", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]:
        """
        List of associated tags.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]):
        pulumi.set(self, "tags", value)


class Application(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 anime_sync_categories: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 api_key: Optional[pulumi.Input[str]] = None,
                 base_url: Optional[pulumi.Input[str]] = None,
                 config_contract: Optional[pulumi.Input[str]] = None,
                 implementation: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 prowlarr_url: Optional[pulumi.Input[str]] = None,
                 sync_categories: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 sync_level: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 __props__=None):
        """
        <!-- subcategory:Applications -->Generic Application resource. When possible use a specific resource instead.
        For more information refer to [Application](https://wiki.servarr.com/prowlarr/settings#applications).

        ## Example Usage

        ```python
        import pulumi
        import pulumi_prowlarr as prowlarr

        example = prowlarr.applications.Application("example",
            api_key="APIKey",
            base_url="http://localhost:8686",
            config_contract="LidarrSettings",
            implementation="Lidarr",
            prowlarr_url="http://localhost:9696",
            sync_categories=[
                3000,
                3010,
                3030,
            ],
            sync_level="disabled")
        ```

        ## Import

        import using the API/UI ID

        ```sh
         $ pulumi import prowlarr:Applications/application:Application example 1
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] anime_sync_categories: Anime sync categories.
        :param pulumi.Input[str] api_key: API key.
        :param pulumi.Input[str] base_url: Base URL.
        :param pulumi.Input[str] config_contract: Application configuration template.
        :param pulumi.Input[str] implementation: Application implementation name.
        :param pulumi.Input[str] name: Application name.
        :param pulumi.Input[str] prowlarr_url: Prowlarr URL.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] sync_categories: Sync categories.
        :param pulumi.Input[str] sync_level: Sync level.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] tags: List of associated tags.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ApplicationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        <!-- subcategory:Applications -->Generic Application resource. When possible use a specific resource instead.
        For more information refer to [Application](https://wiki.servarr.com/prowlarr/settings#applications).

        ## Example Usage

        ```python
        import pulumi
        import pulumi_prowlarr as prowlarr

        example = prowlarr.applications.Application("example",
            api_key="APIKey",
            base_url="http://localhost:8686",
            config_contract="LidarrSettings",
            implementation="Lidarr",
            prowlarr_url="http://localhost:9696",
            sync_categories=[
                3000,
                3010,
                3030,
            ],
            sync_level="disabled")
        ```

        ## Import

        import using the API/UI ID

        ```sh
         $ pulumi import prowlarr:Applications/application:Application example 1
        ```

        :param str resource_name: The name of the resource.
        :param ApplicationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ApplicationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 anime_sync_categories: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 api_key: Optional[pulumi.Input[str]] = None,
                 base_url: Optional[pulumi.Input[str]] = None,
                 config_contract: Optional[pulumi.Input[str]] = None,
                 implementation: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 prowlarr_url: Optional[pulumi.Input[str]] = None,
                 sync_categories: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 sync_level: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ApplicationArgs.__new__(ApplicationArgs)

            __props__.__dict__["anime_sync_categories"] = anime_sync_categories
            __props__.__dict__["api_key"] = None if api_key is None else pulumi.Output.secret(api_key)
            __props__.__dict__["base_url"] = base_url
            if config_contract is None and not opts.urn:
                raise TypeError("Missing required property 'config_contract'")
            __props__.__dict__["config_contract"] = config_contract
            if implementation is None and not opts.urn:
                raise TypeError("Missing required property 'implementation'")
            __props__.__dict__["implementation"] = implementation
            __props__.__dict__["name"] = name
            __props__.__dict__["prowlarr_url"] = prowlarr_url
            __props__.__dict__["sync_categories"] = sync_categories
            if sync_level is None and not opts.urn:
                raise TypeError("Missing required property 'sync_level'")
            __props__.__dict__["sync_level"] = sync_level
            __props__.__dict__["tags"] = tags
        secret_opts = pulumi.ResourceOptions(additional_secret_outputs=["apiKey"])
        opts = pulumi.ResourceOptions.merge(opts, secret_opts)
        super(Application, __self__).__init__(
            'prowlarr:Applications/application:Application',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            anime_sync_categories: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
            api_key: Optional[pulumi.Input[str]] = None,
            base_url: Optional[pulumi.Input[str]] = None,
            config_contract: Optional[pulumi.Input[str]] = None,
            implementation: Optional[pulumi.Input[str]] = None,
            name: Optional[pulumi.Input[str]] = None,
            prowlarr_url: Optional[pulumi.Input[str]] = None,
            sync_categories: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
            sync_level: Optional[pulumi.Input[str]] = None,
            tags: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None) -> 'Application':
        """
        Get an existing Application resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] anime_sync_categories: Anime sync categories.
        :param pulumi.Input[str] api_key: API key.
        :param pulumi.Input[str] base_url: Base URL.
        :param pulumi.Input[str] config_contract: Application configuration template.
        :param pulumi.Input[str] implementation: Application implementation name.
        :param pulumi.Input[str] name: Application name.
        :param pulumi.Input[str] prowlarr_url: Prowlarr URL.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] sync_categories: Sync categories.
        :param pulumi.Input[str] sync_level: Sync level.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] tags: List of associated tags.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ApplicationState.__new__(_ApplicationState)

        __props__.__dict__["anime_sync_categories"] = anime_sync_categories
        __props__.__dict__["api_key"] = api_key
        __props__.__dict__["base_url"] = base_url
        __props__.__dict__["config_contract"] = config_contract
        __props__.__dict__["implementation"] = implementation
        __props__.__dict__["name"] = name
        __props__.__dict__["prowlarr_url"] = prowlarr_url
        __props__.__dict__["sync_categories"] = sync_categories
        __props__.__dict__["sync_level"] = sync_level
        __props__.__dict__["tags"] = tags
        return Application(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="animeSyncCategories")
    def anime_sync_categories(self) -> pulumi.Output[Sequence[int]]:
        """
        Anime sync categories.
        """
        return pulumi.get(self, "anime_sync_categories")

    @property
    @pulumi.getter(name="apiKey")
    def api_key(self) -> pulumi.Output[str]:
        """
        API key.
        """
        return pulumi.get(self, "api_key")

    @property
    @pulumi.getter(name="baseUrl")
    def base_url(self) -> pulumi.Output[str]:
        """
        Base URL.
        """
        return pulumi.get(self, "base_url")

    @property
    @pulumi.getter(name="configContract")
    def config_contract(self) -> pulumi.Output[str]:
        """
        Application configuration template.
        """
        return pulumi.get(self, "config_contract")

    @property
    @pulumi.getter
    def implementation(self) -> pulumi.Output[str]:
        """
        Application implementation name.
        """
        return pulumi.get(self, "implementation")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Application name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="prowlarrUrl")
    def prowlarr_url(self) -> pulumi.Output[str]:
        """
        Prowlarr URL.
        """
        return pulumi.get(self, "prowlarr_url")

    @property
    @pulumi.getter(name="syncCategories")
    def sync_categories(self) -> pulumi.Output[Sequence[int]]:
        """
        Sync categories.
        """
        return pulumi.get(self, "sync_categories")

    @property
    @pulumi.getter(name="syncLevel")
    def sync_level(self) -> pulumi.Output[str]:
        """
        Sync level.
        """
        return pulumi.get(self, "sync_level")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Sequence[int]]:
        """
        List of associated tags.
        """
        return pulumi.get(self, "tags")

